Imports mshtml
Imports System.IO
Imports System.Net
Imports System.Text

' Add a reference to Microsoft.mshtml.

Public Class Form1
    Private Const GAP As Integer = 4

    ' Navigate to the entered URL.
    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        Try
            wbrWebSite.Navigate(txtUrl.Text)
        Catch ex As Exception
            MessageBox.Show("Error navigating to web site " & _
                txtUrl.Text & vbCrLf & ex.Message, _
                "Navigation Error", _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Error)
        End Try
    End Sub

    ' Show the images from the URL.
    Private m_Running As Boolean = False
    Private Sub btnListImages_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnListImages.Click
        If btnListImages.Text = "List Images" Then
            Me.Cursor = Cursors.WaitCursor
            btnListImages.Text = "Stop"
            btnGo.Enabled = False
            btnSaveImages.Enabled = False
            Application.DoEvents()

            ' Remove old images.
            For i As Integer = flpPictures.Controls.Count - 1 To 0 Step -1
                flpPictures.Controls(i).Parent = Nothing
            Next i

            ' List the images on this page.
            Dim doc As System.Windows.Forms.HtmlDocument = wbrWebSite.Document
            m_Running = True
            For Each element As HtmlElement In doc.Images
                Dim dom_element As mshtml.HTMLImg = element.DomElement
                Dim src As String = dom_element.src

                Dim pic As New PictureBox()
                pic.BorderStyle = BorderStyle.Fixed3D
                pic.SizeMode = PictureBoxSizeMode.AutoSize
                pic.Image = GetPicture(src)
                pic.Parent = flpPictures
                pic.Tag = src
                tipFileName.SetToolTip(pic, src)

                AddHandler pic.Click, AddressOf pic_Click

                Application.DoEvents()

                If Not m_Running Then Exit For
            Next element
            m_Running = False

            btnListImages.Text = "List Images"
            btnGo.Enabled = True
            btnSaveImages.Enabled = True
            Me.Cursor = Cursors.Default
        Else
            m_Running = False
        End If
    End Sub

    ' Get the picture at a given URL.
    Private Function GetPicture(ByVal url As String) As Image
        Try
            url = Trim(url)
            If Not url.ToLower().StartsWith("http://") Then url = "http://" & url
            Dim web_client As New WebClient()
            Dim image_stream As New MemoryStream(web_client.DownloadData(url))
            Return Image.FromStream(image_stream)
        Catch ex As Exception
            MessageBox.Show("Error downloading picture " & _
                url & vbCrLf & ex.Message, _
                "Download Error", _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Error)
        End Try
        Return Nothing
    End Function

    ' Remove the clicked PictureBox.
    Private Sub pic_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim pic As PictureBox = DirectCast(sender, PictureBox)
        pic.Parent = Nothing
    End Sub

    ' Stop. This may take a little while as pending downloads complete.
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        m_Running = False
    End Sub

    ' Set the initial save directory.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        txtDirectory.Text = Application.StartupPath
    End Sub

    ' Save the images that have not been removed.
    Private Sub btnSaveImages_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImages.Click
        Dim dir_name As String = txtDirectory.Text
        If Not dir_name.EndsWith("\") Then dir_name &= "\"

        For Each pic As PictureBox In flpPictures.Controls
            Dim bm As Bitmap = pic.Image
            Dim filename As String = pic.Tag
            filename = filename.Substring(filename.LastIndexOf("/") + 1)
            Dim ext As String = filename.Substring(filename.LastIndexOf("."))
            Dim full_name As String = dir_name & filename

            Select Case ext
                Case ".bmp"
                    bm.Save(full_name, Imaging.ImageFormat.Bmp)
                Case ".gif"
                    bm.Save(full_name, Imaging.ImageFormat.Gif)
                Case ".jpg", "jpeg"
                    bm.Save(full_name, Imaging.ImageFormat.Jpeg)
                Case ".png"
                    bm.Save(full_name, Imaging.ImageFormat.Png)
                Case ".tiff"
                    bm.Save(full_name, Imaging.ImageFormat.Tiff)
                Case Else
                    MessageBox.Show( _
                        "Unknown file type " & ext & _
                        " in file " & filename, _
                        "Unknown File Type", _
                        MessageBoxButtons.OK, _
                        MessageBoxIcon.Error)
            End Select
        Next pic

        Beep()
    End Sub
End Class
